Option Explicit
'Plasmatronics 2020.10.14

'Never expose the DNET to the internet. Always use a VPN
'for remote access.

'The Dingo register map is available for download:
'http://www.plasmatronics.com.au/downloads/DUSB_and_D232_Communications_v0.3.pdf

'For more information, see DNET.txt.

'ENTER CORRECT DNET ADDRESS HERE:

const    DNETaddress = "192.168.1.221"	'or "DNnnnn"
const    DNETport = 502			'ModBus port

dim sPath, sCsvFile, sHeading

    sHeading = "Time, Battery Woltage, Dingo Clock"

    sPath = CreateObject("Wscript.Shell").SpecialFolders("Mydocuments")
    sCSVfile = sPath & "\dvolt.csv"		'EXAMPLE
    'sCSVfile = "C:\storage\dvolt.txt"		'EXAMPLE

    Call RunIn32BitSystem	'restart script if required


Dim oWinsock
Dim gsBuffer 
Dim bClose, gSocketError 
dim gsPacket
dim gnPacket	'modbus packet number 
dim i,a
dim hexpacket
dim rx_packet_header
dim volt, voltposition, clck, clckposition

'EXAMPLE: GET 16 REGISTERS FROM 4096 (0x1000) USING MODBUS/TCP
  gsPacket = mbPacket(1,3,&H1000,16)
  rx_packet_header = " 0 1 0 0 0 23 1 3 20 "	'spaced out hex values
  voltposition = 18	'volt, at &H1004, is 8 places after the start of data at 10.
  clckposition = 13	'12,13,14,15
'0x20 = 16*2, 0x23=0x20+3  (16 registers)


'EXAMPLE: GET Voltage FROM 4100 (0x1004) USING MODBUS/TCP
'  gsPacket = mbPacket(1,3,4100,1)
'  rx_packet_header = " 0 1 0 0 0 5 1 3 2 "	'spaced out hex values
'  voltposition = 10				'data starts after first 9 bytes.
'0x2 = 1*2, 0x5 = 0x2+3	  (1 register)

'THE RX PACKET HEADER IS USED BELOW FOR A SIMPLE RESPONSE CHECK.


  bClose = False
  Set oWinsock = CreateObject("OSWINSCK.Winsock")

  'bind object to event handlers in the currently executing script.
  WScript.ConnectObject oWinsock, "oWinsock_"

  'on connect event sends gsPacket
  'connection failure won't error here: it will generate a timeout
  'which is caught by the "on error" handler below.

  oWinsock.Connect DNETaddress, DNETport


  While Not bClose	'bclose will be set below by a packet response or timeout
    WScript.Sleep 1
  Wend

  if gSocketError then wscript.quit

  'FOR DEBUG AND COMPARISON, MAKE A SPACE-DELIMITED HEX COPY OF THE PACKET:
  for i = 1 to len(gsBuffer)
    hexpacket = hexpacket & " " & hex(asc(mid(gsBuffer,i,1)))
  next


  if (len(gsBuffer)>= 11) and (left(hexpacket, len(rx_packet_header))=rx_packet_header) then
     volt = asc(mid(gsBuffer,voltposition,1))	'data starts from position 10
     volt = (volt*256) + asc(mid(gsBuffer,voltposition+1,1))

     clck = asc(mid(gsBuffer, clckposition,1))
     clck = cdate((clck + (6*asc(mid(gsBuffer,clckposition+2,1)))) / 1440) 'clock

     'WriteCSV volt/10			'example writing a single value

     a = array(volt/10,clck)		'create an array of values
     writeAcsv(a)



  else
     WriteCSV "error" & hexpacket
  end if



'-----------------------------------------------------
sub WriteACSV( A)
'EXAMPLE FOR WRITING An array

dim fso, csvfile, write_heading,x

    Set fso = CreateObject("Scripting.FileSystemObject")	

    if not fso.FileExists(scsvfile) Then 
	write_heading=true
    end if

    set csvfile = fso.opentextfile(scsvfile,8,true) 'append, create if missing

    if write_heading then csvfile.writeline(sHeading)

    csvfile.write(now)
    for each x in a
    	csvfile.write(", " & x)
    next
    csvfile.writeline()

    csvfile.close

end sub

sub WriteCSV( a)
'EXAMPLE FOR WRITING A SINGLE VALUE

dim fso, csvfile, write_heading

    Set fso = CreateObject("Scripting.FileSystemObject")	

    if not fso.FileExists(scsvfile) Then 
	write_heading=true
    end if

    set csvfile = fso.opentextfile(scsvfile,8,true) 'append, create if missing

    if write_heading then csvfile.writeline(sHeading)

    csvfile.writeline(now & ", " & a )
    csvfile.close

end sub

'----------------------------------------------------------------------
'EXAMPLE FOR SCALING VALUES FROM FF00, FF01, B2
function scale_dingo_status(laFF00 , laFF01, laB2, errcode, sErr)
Dim temp
Dim batv, vmult,svdelta
Dim volt, stat
Dim voltIndex, statIndex
volt = Array(12, 24, 32, 36, 48, 0)
stat = Array("boost", "equl", "absb", "float", "ERROR")

dim aData(31)

    errCode = 0
    'aData(0) = Now()    

    statIndex = (laFF00(14) \ &H40) And &H3
    If statIndex > UBound(stat) Then
        statIndex = UBound(stat)
        If errcode = 0 Then
            errcode = -1
            sErr = "Data Error"
        End If
    End If
    
    voltIndex = laFF00(1) And &HF
    If voltIndex > UBound(volt) Then
        voltIndex = UBound(volt)
        If errcode = 0 Then
            errcode = -2
            sErr = "Data Error"
        End If
    End If
    

    vmult = volt(voltIndex) / 12.0
    batv = ((laFF00(5)*256.0) + laFF00(6)) / 10.0
    

    temp = laFF00(4)                                    'Battery temperature
    If temp = 128 Then temp = ""

    aData(3) = stat(statIndex)    		'Regulator Mode state ((laFF00(14) \ &H40) And &H3)
    aData(4) = batv     			'Battery voltage (laFF00(5), laFF00(6))
    aData(5) = vmult * laFF00(7) / 10        		'Regulation target voltage
    aData(6) = vmult * laFF00(12) / 10 			'Day max battery voltage
    aData(7) = vmult * laFF00(13) / 10 			'Day min battery voltage
    aData(8) = laFF00(11)        			'State of Charge
    aData(9)  =((laFF01( 1) * 256) + laFF01( 2) + (laFF01( 9) * 256) + laFF01(10)) / 10 'charge current
    aData(10) = (laFF01(11) * 256) + laFF01(12)	'AH charge
    aData(11) =((laFF01( 5) * 256) + laFF01( 6) + (laFF01(13) * 256) + laFF01(14))/ 10 	'load current
    aData(12) = (laFF01(15) * 256) + laFF01(16)	'AH
    if laFF00(10) <= 241 then
     	aData(13) = cdate(laFF00(10) * 6 / 1440)  	'Clock time we went into float
    end if
    aData(14) = laFF00(9)              		'Days since last boost
    aData(15) = laFF00(8)              		'Days since equalization
    aData(16) = temp				'temperature (laFF00(4))
    aData(17) = cdate(((laFF00(3) * 6) + laFF00(2)) / 1440) 'clock
    aData(18) = volt(voltIndex)      		'VOLT setting value (laFF00(1) And &HF)
    aData(19) = (laFF00(1) And &HF0) \ &H10    'PROG setting value
        
    aData(21) = (laFF00(14)) And 1             'Load State
    aData(22) = (laFF00(14) \ &H2) And 1       'Generator State
    aData(23) = (laFF00(14) \ &H4) And 1       'Event controller state
    aData(24) = (laFF00(14) \ &H8) And 1       'Charge protection state
    aData(25) = (laFF00(14) \ &H10) And 1      'Alarm State
    aData(26) = (laFF00(14) \ &H20) And 1      'Load protection state
    aData(27) = (laFF00(14) \ &H40) And &H3    'Regulator Mode state
    
    svdelta = (laB2(1) * 256) + laB2(2)        'solar voltage
    If svdelta < 28 Then
        aData(29) = 0
    Else
        aData(29)= batv + (svdelta / 10)       'solar voltage
    End If

    scale_dingo_status = aData

End function


'-- 32/64 bit system --------------------------------------------------

sub RunIn32BitSystem()
	If Is64BitOS() and wscript.arguments.count = 0 then
		if 0=instr(wscript.fullname,"SysWow64") then
			dim sscript,path,objShell

			if instr(lcase(WScript.FullName),"cscript") then sscript="cscript" else sscript="wscript"
			
			path = wscript.CreateObject("Shell.application").NameSpace("shell:Systemx86").self.path
			'path = "c:\Windows\SysWoW64"
			'shell.Systemx86 is also mapped to index 41.

			Set objShell = WScript.CreateObject("WScript.Shell")
			objShell.Run path & "\" & sscript & " """&  Wscript.ScriptFullName &""" """ & "InScript""", 0,True
			Set objShell = Nothing
			wscript.quit
		end if
	end if

end sub

Function Is64BitOS()
on error resume next	'AddressWidth property is not supported on WinXP
    Const Path = "winmgmts:root\cimv2:Win32_Processor='cpu0'"
    Is64BitOS = (GetObject(Path).AddressWidth = 64)
End Function


'-- mb utilities -----------------------------------------------------

Function sMBint(wValue)
Dim LO 'As Byte
Dim HI 'As Byte
    LO = wValue And &HFF&
    HI = (wValue And &HFF00&) \ 256
    sMBint = Chr(HI) + Chr(LO)
End Function


function MBpacket(SlaveAddr, FuncCode, RegAddr, recCount)
Dim s 'As String
Dim n 'As Integer
Dim sTransID 'As String
Dim sProtID 'As String
Dim sLen    'As String
Dim sReg    'As String
Dim sNum    'As String


    gnPacket = gnPacket + 1
    
    sTransID = sMBint(gnPacket)
    sProtID = sMBint(0)
    sReg = sMBint(CInt(RegAddr))
    sNum = sMBint(recCount)
    
    s = Chr(SlaveAddr) + Chr(funcCode) + sReg + sNum

    n = Len(s)
    
    s = sTransID + sProtID + sMBint(n) + s
    MBpacket = s
End Function


'---event handlers------------------------------------

Sub oWinsock_OnClose()
  oWinsock.CloseWinsock

  Set oWinsock = Nothing
  bClose = True
End Sub


Sub oWinsock_OnConnect()
  oWinsock.SendData gsPacket
End Sub


Sub oWinsock_OnDataArrival(ByVal bytesTotal)
'By default, OSwinsck puts character representations into a string.
'It doesn't matter what the system character mapping is, just that
'vbscript is using the same mapping as OSwinsck: values round-trip
'correctly.asc(char(asc)).

'DNET data will be a single small packet, so don't bother trying to
'collect multiple packets. Just ignore bytesTotal unless you have
'problems.

	oWinsock.GetData gsBuffer
End Sub


Sub oWinsock_OnError(ByVal Number, Description, _
    ByVal Scode, ByVal Source, ByVal HelpFile, _
    ByVal HelpContext, CancelDisplay)

'connection timeouts come here.

ON ERROR RESUME NEXT

	oWinsock.CloseWinsock
	writeCSV now,"error " & Number & ": " & Description
	dim oShell
	Set oShell = CreateObject("WScript.Shell")
	oShell.LogEvent 1, "DNET logging script" & vblf _
		& WScript.ScriptFullName & vblf _
		& "socket error " & Number & ": " & Description 

	bClose = True		'stop waiting for data
	gSocketError = Number	'don't try to report data

End Sub

